csKDTree Class Reference (Crystal Space 2.0 Public API Reference)

| ## Public API Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions
csKDTree Class Reference
Geometry utilities

A KD-tree. More...

`#include <csgeom/kdtree.h>`

Inheritance diagram for csKDTree:

List of all members.

## Public Member Functions
csKDTreeChild * | AddObject (const csBox3 &bbox, void *object)
| Add an object to this kd-tree node.
virtual csTicks | Benchmark (int num_iterations)
| Perform a benchmark.
void | Clear ()
| Make the tree empty.
| csKDTree ()
| Create a new empty KD-tree.
virtual bool | DebugCommand (const char *)
| Perform a debug command as defined by the module itself.
void | Distribute ()
| Distribute all objects in this node to its children.
virtual csPtr< iString > | Dump ()
| Do a text dump of the current state of this object.
virtual void | Dump (iGraphics3D *)
| Do a graphical dump of the current state of this object.
void | Flatten ()
| Do a full flatten of this node.
void | Front2Back (const csVector3 &pos, csKDTreeVisitFunc *func, void *userdata, uint32 frustum_mask)
| Traverse the tree from front to back.
void | FullDistribute ()
| Do a full distribution of this node and all children.
csKDTree * | GetChild1 () const
| Get child one.
csKDTree * | GetChild2 () const
| Get child two.
int | GetEstimatedObjectCount ()
| Get the estimated total number of objects in this node and all children.
const csBox3 & | GetNodeBBox () const
| Return the bounding box of the node itself (does not always contain all children since children are not split by the tree).
int | GetObjectCount () const
| Return the number of objects in this node.
csKDTreeChild ** | GetObjects () const
| Return the array of objects in this node.
virtual int | GetSupportedTests () const
| Return a bit field indicating what types of functions this specific unit test implementation supports.
iKDTreeUserData * | GetUserObject () const
| Get the user object attached to this node.
void | MoveObject (csKDTreeChild *object, const csBox3 &new_bbox)
| Move an object (give it a new bounding box).
uint32 | NewTraversal ()
| Start a new traversal.
void | RemoveObject (csKDTreeChild *object)
| Remove an object from the kd-tree.
void | SetMinimumSplitAmount (int m)
| Set the minimum amount of objects before we consider splitting this tree.
void | SetObjectDescriptor (iKDTreeObjectDescriptor *descriptor)
| For debugging: set the object descriptor.
void | SetParent (csKDTree *p)
| Set the parent.
void | SetUserObject (iKDTreeUserData *userobj)
| Set the user object for this node.
virtual csPtr< iString > | StateTest ()
| Perform a state test.
void | TraverseRandom (csKDTreeVisitFunc *func, void *userdata, uint32 frustum_mask)
| Traverse the tree in random order.
void | UnlinkObject (csKDTreeChild *object)
| Unlink an object from the kd-tree.
virtual | ~csKDTree ()
| Destroy the KD-tree.

## Detailed Description

A KD-tree.

A KD-tree is a binary tree that organizes 3D space. This implementation is dynamic. It allows moving, adding, and removing of objects which will alter the tree dynamically. The main purpose of this tree is to provide for an approximate front to back ordering.

The KD-tree supports delayed insertion. When objects are inserted in the tree they are not immediatelly distributed over the nodes but instead they remain in the main node until it is really needed to distribute them. The advantage of this is that you can insert/remove a lot of objects in the tree and then do the distribution calculation only once. This is more efficient and it also generates a better tree as more information is available then.

Definition at line 167 of file kdtree.h.

## Constructor & Destructor Documentation

csKDTree::csKDTree | ( |  | ) |

Create a new empty KD-tree.

virtual csKDTree::~csKDTree | ( |  | ) | `[virtual]`

Destroy the KD-tree.

## Member Function Documentation

csKDTreeChild* csKDTree::AddObject | ( | const csBox3 & | bbox,
|  | void * | object
| ) |  |

Add an object to this kd-tree node.

Returns a csKDTreeChild pointer which represents the object inside the kd-tree. Object addition is delayed. This function will not yet alter the structure of the kd-tree. Distribute() will do that.

virtual csTicks csKDTree::Benchmark | ( | int | num_iterations | ) | `[inline, virtual]`

Perform a benchmark.

This function will return a number indicating how long the benchmark lasted in milliseconds.

Implements iDebugHelper.

Definition at line 440 of file kdtree.h.

void csKDTree::Clear | ( |  | ) |

Make the tree empty.

virtual bool csKDTree::DebugCommand | ( | const char * | cmd | ) | `[inline, virtual]`

Perform a debug command as defined by the module itself.

Returns 'false' if the command was not recognized.

Implements iDebugHelper.

Definition at line 453 of file kdtree.h.

void csKDTree::Distribute | ( |  | ) |

Distribute all objects in this node to its children.

This may also create new children if needed. Note that this will only distribute one level (this node) and will not recurse into the children.

virtual csPtr<iString> csKDTree::Dump | ( |  | ) | `[inline, virtual]`

Do a text dump of the current state of this object.

Returns 0 if not supported or else a string which you should DecRef() after use.

Implements iDebugHelper.

Definition at line 445 of file kdtree.h.

virtual void csKDTree::Dump | ( | iGraphics3D * | g3d | ) | `[inline, virtual]`

Do a graphical dump of the current state of this object.

Implements iDebugHelper.

Definition at line 452 of file kdtree.h.

void csKDTree::Flatten | ( |  | ) |

Do a full flatten of this node.

This means that all objects are put back in the object list of this node and the KD-tree children are removed.

void csKDTree::Front2Back | ( | const csVector3 & | pos,
|  | csKDTreeVisitFunc * | func,
|  | void * | userdata,
|  | uint32 | frustum_mask
| ) |  |

Traverse the tree from front to back.

Every node of the tree will be encountered. The mask parameter is optionally used for frustum checking. Front2Back will pass it to the tree nodes.

void csKDTree::FullDistribute | ( |  | ) |

Do a full distribution of this node and all children.

csKDTree* csKDTree::GetChild1 | ( |  | ) | const`[inline]`

Get child one.

Definition at line 385 of file kdtree.h.

csKDTree* csKDTree::GetChild2 | ( |  | ) | const`[inline]`

Get child two.

Definition at line 390 of file kdtree.h.

int csKDTree::GetEstimatedObjectCount | ( |  | ) | `[inline]`

Get the estimated total number of objects in this node and all children.

This is only an estimate as it isn't kept up-to-date constantly but it should give a rough idea about the complexity of this node.

Definition at line 403 of file kdtree.h.

const csBox3& csKDTree::GetNodeBBox | ( |  | ) | const`[inline]`

Return the bounding box of the node itself (does not always contain all children since children are not split by the tree).

Definition at line 414 of file kdtree.h.

int csKDTree::GetObjectCount | ( |  | ) | const`[inline]`

Return the number of objects in this node.

Definition at line 395 of file kdtree.h.

csKDTreeChild** csKDTree::GetObjects | ( |  | ) | const`[inline]`

Return the array of objects in this node.

Definition at line 408 of file kdtree.h.

virtual int csKDTree::GetSupportedTests | ( |  | ) | const`[inline, virtual]`

Return a bit field indicating what types of functions this specific unit test implementation supports.

This will return a combination of the CS_DBGHELP_... flags:

- CS_DBGHELP_BENCHMARK
- CS_DBGHELP_TXTDUMP
- CS_DBGHELP_GFXDUMP
- CS_DBGHELP_STATETEST

Implements iDebugHelper.

Definition at line 425 of file kdtree.h.

iKDTreeUserData* csKDTree::GetUserObject | ( |  | ) | const`[inline]`

Get the user object attached to this node.

Definition at line 301 of file kdtree.h.

void csKDTree::MoveObject | ( | csKDTreeChild * | object,
|  | const csBox3 & | new_bbox
| ) |  |

Move an object (give it a new bounding box).

uint32 csKDTree::NewTraversal | ( |  | ) |

Start a new traversal.

This will basically make a new timestamp and return it. You can then use that timestamp to check if objects have been visited already. This function is automatically called by Front2Back() but it can be useful to call this if you plan to do a manual traversal of the tree.

void csKDTree::RemoveObject | ( | csKDTreeChild * | object | ) |

Remove an object from the kd-tree.

The 'csKDTreeChild' instance will be deleted.

void csKDTree::SetMinimumSplitAmount | ( | int | m | ) | `[inline]`

Set the minimum amount of objects before we consider splitting this tree.

By default this is set to 1.

Definition at line 295 of file kdtree.h.

void csKDTree::SetObjectDescriptor | ( | iKDTreeObjectDescriptor * | descriptor | ) | `[inline]`

For debugging: set the object descriptor.

Definition at line 286 of file kdtree.h.

void csKDTree::SetParent | ( | csKDTree * | p | ) | `[inline]`

Set the parent.

Definition at line 283 of file kdtree.h.

void csKDTree::SetUserObject | ( | iKDTreeUserData * | userobj | ) |

Set the user object for this node.

Can be 0 to clear it. The old user object will be DecRef'ed and the (optional) new one will be IncRef'ed.

virtual csPtr<iString> csKDTree::StateTest | ( |  | ) | `[inline, virtual]`

Perform a state test.

This function will test if the current state of the object is ok. It will return 0 if it is ok. Otherwise an iString is returned containing some information about the errors. DecRef() this returned string after using it.

Implements iDebugHelper.

Definition at line 431 of file kdtree.h.

void csKDTree::TraverseRandom | ( | csKDTreeVisitFunc * | func,
|  | void * | userdata,
|  | uint32 | frustum_mask
| ) |  |

Traverse the tree in random order.

The mask parameter is optionally used for frustum checking. TraverseRandom will pass it to the tree nodes.

void csKDTree::UnlinkObject | ( | csKDTreeChild * | object | ) |

Unlink an object from the kd-tree.

The 'csKDTreeChild' instance will NOT be deleted.

The documentation for this class was generated from the following file:

- csgeom/kdtree.h